package jTunnel;

import java.net.*;
import java.io.*;
import java.util.StringTokenizer;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 * It's mostly designed to open connections thru 
 * a firewall Ijt.class is the class to run on a 
 * computer "Inside" the firewall zone
 * Ojt.class is the class to run on an outside computer
 * Ijt will connect to Ojt and create a "Tunnel" where 
 * all the outside requests will transit. Ijt then open 
 * as much sockets as needed. 
 * "for more details read the code :)"
 * <pre>
 * Well how to make it works. ..
 * on the Outside computer type 
 *   "java Ojt <Tunnel Port>"
 * on the Inside computer type 
 *   "java Ijt <Outside Computer name> <Tunnel Port> <Wait Time>"
 *       (Wait Time) is the time in minutes Ijt will wait if the 
 *       connection is aborded
 * now only the servers are running.
 * to affect a port on the Outside computer to the 
 * inside world type "telnet <Outside computer name> <Tunnel Port>"
 * once logged in type "hello" to show you are a human
 * then "help" will give u some help
 *
 * Exemple: O = outside computer ; I = inside computer
 * O# java Ojt 1080 > O.log & 
 * I# java Ijt O.perki.org 1080 10 > I.log &
 * O# telnet localhost 1080
 *    hello
 *    open 2080 toto.inside.net 80
 *    quit
 * 
 * Now if you use the port 2080 of 0.perki.org you will be
 * connected to the port 80 of toto.inside.net 
 *
 * You can also specify all the connections to open at stratup:
 * O# java Ojt 1080 2080 toto.inside.net 80 2023 toto.inside.net 23
 *    this is equal to : open 2080 toto.inside.net 80
 *                       open 2023 toto.inside.net 23
 *   
 * </PRE>
 * This is free software as long as you don't make money with it.
 * To build JTunnel I used a lot of code from proxy.java writen
 * by  Matthias L. Jugel .. Thanx
 * @version 1.0b3 10/04/98
 * @author Pierre-Mikael legris (plegris@fbwww.epfl.ch) 
 * @author Philippe Rochat (Philippe.Rochat@epfl.ch)
 */


public class Ojt implements Runnable
{
  static Hashtable queue = new Hashtable();
  static Hashtable proxs = new Hashtable();
  static Hashtable proxl = new Hashtable();
  static PrintStream mainStream = null;
  static boolean Mb = false;
  String insideHost;
  int mainPort, basePort;
  
  Thread server, connection;
  
  ServerSocket MSocket;
  
  // Ojt Port Port
  public Ojt(int m_port)
  {
    mainPort = m_port;
    
    log("Main Port is  "+mainPort);
    try {
      MSocket = new ServerSocket(mainPort);
    } catch(Exception e) {
      System.out.println("Ojt: error: cannot create server socket");
    }
    log("listening on ports "+ mainPort );
    
    server = new Thread(this);
    server.setPriority(Thread.MIN_PRIORITY);
    server.start();
  } 
  
  // This is the startpoint
  /** 
   * usage: Ojt <Main port>
   */
  public static void main(String args[]) 
  {
    String insideHost = "";
    int mainPort = 0, basePort = 0;
    
    //get the port to bind
    if(args.length == 0)
      {
	System.out.println("Ojt: usage: Ojt <Main port>");
	System.exit(1);
      }
    try {
      mainPort = Integer.parseInt(args[0]);
    } catch(Exception e) {
      System.out.println("Ojt-: usage: Ojt <Main port>");
      System.exit(1);
    }
    
    // are they some opens to do now?
    try {
      for (int i = 1 ; i < args.length ; i = i + 3) 
	{
	 
	  int mport = Integer.parseInt(args[i]);
	  String dhost =  "" + args[i + 1];
	  int dport = Integer.parseInt(args[i + 2]);
	  Jprox bouarf = new Jprox(mport,dhost,dport);
	}
    } catch(Exception e) {
      System.out.println("Ojt: usage: Ojt <Main port>");
      System.exit(1);
    }
	
    Ojt me = new Ojt(mainPort);
  }

  // wait for connection and check is the Inside bound still alive
  public void run()
  {
    Socket mainSocket = null;
    while(true)
    { 
     
      try {
	mainSocket = MSocket.accept();
	
      } catch(Exception e) {
	System.out.println("Ojt: error: main accept connection failed");
	break;
      }     
      log("accepted main connection from "+ mainSocket.getInetAddress().getHostName());
      
      // send the studd to the huf
      socketHub(mainSocket);
    }
  }

  private void socketHub(Socket mainSocket) 
  {
    Socket Hsocket = null;
    DataInputStream IH = null;
    PrintStream PH = null;
     // try 
    try {
      // Open Hsocket and stream
      Hsocket = mainSocket;
      IH = new DataInputStream(Hsocket.getInputStream());
      PH = new PrintStream(Hsocket.getOutputStream());
      
      } // try 1
    catch(Exception e) {
      log("cannot open Hsocket") ;
    }
    
    String ligne = "";
    while ( ligne.compareTo("") == 0 ) 
      {
	try {
	  ligne=IH.readLine();
	  try {
	    Thread.sleep(100);
	  } 
	  catch(InterruptedException e){ }
	}
	catch (Exception e) { break ;} 
      }
    String lt = "";
    if ( ligne != "" ) 
      {
	boolean ok = false;
	StringTokenizer st = new StringTokenizer(ligne);
	if (st.hasMoreTokens()) 
	  lt = st.nextToken();
	
	// MAIN connection
	if (lt.compareTo("main") == 0)
	  {
	    try {
	      if (Mb) {
		log("fake connection attempt ");
	      } else {
		ok = true;
		log("Main connection opened");
		Mb = true;
		this.mainStream = new PrintStream(Hsocket.getOutputStream());
		checkMain check = new checkMain(Hsocket);
	      } 
	    } catch(Exception e) {log("failed while main acknowlegment");}
	  }
	
	// ID
	if ((lt.compareTo("id") == 0) && st.hasMoreTokens())
	  {
	    String id = st.nextToken();
	    Socket IDsocks = (Socket) queue.get(id) ;
	    ok = true;
	    log("getting id: " + id + " is back --> redirect");
	    try {
	      redirector r1 = new redirector(Hsocket, IDsocks);
	      redirector r2 = new redirector(IDsocks, Hsocket);
	      r1.couple(r2);
	      r2.couple(r1);
	    } catch(Exception e) {
	      System.out.println("Ojt: error: cannot create sockets for" + id);
	    }
	    queue.remove(id);
	    log("##ok "+id+" is redirected ");
	  }
	
	// Human
	if (lt.compareTo("hello") == 0)
	  {
	    ok = true;
	    log("human logging");
	    console human = new console(Hsocket);
	  }
	if (! ok) {
	  try {
	    log("Wrong keyword");
	    Hsocket.close();
	  } catch(Exception e) {}
	}
      }   
  }

 
  // LOG
  private void log(String msg)
  {
    System.out.println("Ojt: "+msg);
  }
}

// Little class that checks if the Tunnel is open
class checkMain implements Runnable
{
  private Socket MySocks = null;
  private DataInputStream MyR;
  public checkMain(Socket Hsocket)
  {
    try {
      MySocks = Hsocket;
      MyR = new DataInputStream(MySocks.getInputStream());
    }  catch(Exception e) {
      System.out.println("checkMain: cannot get main streams");
      Ojt.Mb = false;
    }
    Thread ChM = new Thread(this);
    ChM.start();
  }
  public void run()
  {
    System.out.println("checkMain: checking stream");
    // wait while it dies
    try {
      String ligne=MyR.readLine();
      try{
	Thread.sleep(1000);
      }  
      catch(InterruptedException e){ }
    }
    catch (Exception e) { }
    System.out.println("checkMain: lost main stream");
    Ojt.Mb = false;
  }
}// CheckMain

// Human console
class console implements Runnable
{
  private Socket MySocks = null;
  private Thread IO;
  
  public console(Socket Hsocket) 
  {
    try {
      MySocks = Hsocket;
    }  catch(Exception e) { 
      System.out.println("console: cannot get human streams"); 
    }
    
    Thread IO = new Thread(this);
    IO.start();
  } 
  
  public void run()
  {
    DataInputStream MyR = null;
    PrintStream MyP = null;
    try {
      MyR = new DataInputStream(MySocks.getInputStream());
      MyP = new PrintStream(MySocks.getOutputStream());
      if (! Ojt.Mb ) MyP.println("#### MainStream is Closed ####");
    } catch(Exception e) { System.out.println("console: human connection failed");}
    
     System.out.println("console: human console opened");
    String ligne = "";
    while ( MySocks != null ) {
      try {
	ligne=MyR.readLine();
	String tmp = "" ;
	String command = "";
	StringTokenizer st = new StringTokenizer(ligne);
	if (st.hasMoreTokens()) {
	  command = st.nextToken();
	  
	  //help
	  if (command.compareTo("help") == 0) {
	     MyP.println("JTunnel by Perki ( based on Matthias L. Jugel proxy.java)\n open <local port> <host> <host port> : will bind a host,port\n ls  : list all the bindings \n kill <localport|all>  : kill one or all the bindings \n quit : quit the console"); 
	    
	  }
	  
	  //open command
	  if ((command.compareTo("open") == 0) && ( st.countTokens() == 3)) {
	    int mport = Integer.valueOf(st.nextToken()).intValue();
	    String dhost = st.nextToken();
	    int dport = Integer.valueOf(st.nextToken()).intValue();
	    Jprox prox = new Jprox(MyP, mport , dhost , dport);
	    Ojt.proxl.put("" + mport ,"  "+mport+"  " + dhost + ":"+dport);
	  }
	  
	  // ls
	  if (command.compareTo("ls") == 0)
	    {
	      for (Enumeration e = Ojt.proxl.keys() ; e.hasMoreElements() ;) {
		MyP.println(Ojt.proxl.get(e.nextElement()));
	      }
	    }
	  
	  // quit
	   if (command.compareTo("quit") == 0)
	     {
	       MyP.println("Zorglub!!!!!");
	       try 
		 {
		   MySocks.close();
		 } catch(Exception e) { }
	     }

	  // kill
	  if ((command.compareTo("kill") == 0) && st.hasMoreTokens()) 
	    {
	      String tk = st.nextToken();
	      if (tk.compareTo("all") == 0) {
		for (Enumeration e = Ojt.proxs.keys() ; e.hasMoreElements() ;) {
		  String ke = (String) e.nextElement();
	 	  Thread tokill = (Thread)  Ojt.proxs.get(ke);
 		  tokill.stop();
	 	  Ojt.proxs.remove(ke);
		  Ojt.proxl.remove(ke);
		} 
		MyP.println("  all proxies closed");
	      } else {
		Thread tokill = (Thread)  Ojt.proxs.get(tk);
		tokill.stop();
		Ojt.proxs.remove(tk);
		Ojt.proxl.remove(tk);
		MyP.println("  proxy " + tk + " closed ");
	      }
	    }
	}
	try{
	  Thread.sleep(100);
	}  
	catch(InterruptedException e){ }
      }
      catch (Exception e) { 
	 System.out.println("console: lost Human connection"); 
	break;
      } 
    }
  }
}

// The one who does the real proxy job
class Jprox implements Runnable
{
  private String destHost;
  private int destPort;
  private int myPort;
  private PrintStream human;
  private Thread GoForest;
  private boolean FromConsole = false;
  private ServerSocket server;
  

  public Jprox(PrintStream MyP, int mport, String dhost, int dport) 
  {
    human = MyP;
    FromConsole = true;
    Jpro(mport,dhost, dport);
  }
  
  public Jprox(int mport, String dhost, int dport) 
  {
   Jpro(mport,dhost, dport); 
  }

  private void Jpro(int mport, String dhost, int dport) 
  {
    myPort = mport;
    destHost = dhost;
    destPort = dport;
    HUM("  new Jprox "+myPort+":"+destPort+" on "+destHost);
    try {
      server = new ServerSocket(myPort);
    } catch(Exception e) {
      HUM("  Jprox: "+myPort+" cannot create server socket");
    } 
    HUM("  Jprox: "+myPort+" Listening");
    
    GoForest = new Thread(this);
    GoForest.setPriority(Thread.MIN_PRIORITY);
    GoForest.start();
    Ojt.proxs.put("" + myPort , GoForest );
  }
  
  public void run()
  {
    Socket localSocket = null;
    while(true)
      {
	try {
	  localSocket = server.accept();
	} catch(Exception e) {
	  System.out.println("Jprox: "+myPort+" error: accept connection failed");
	  break;
	}
	if (Ojt.Mb) {
	  String id = "" + localSocket.getInetAddress().getHostName() + localSocket.getPort();
	  Ojt.queue.put(id,localSocket);
	  Ojt.mainStream.println(""+id+" "+destHost+" "+destPort);
	  System.out.println("Jprox: "+myPort+"connected to" + id );
	} else {
	  try {
	    localSocket.close();
	    System.out.println("Jprox: "+myPort+" MainStream was out closed!");
	  } catch(Exception e) { }
	}
      }
  }
  
  private void HUM (String text) 
  {
    if (FromConsole) {
      human.println(text);
    } else {
      System.out.println(text);
    }
  }
  
}




      








